sync.yaml 6.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167
  1. kind: DaemonSet
  2. apiVersion: apps/v1
  3. metadata:
  4. name: sync
  5. namespace: openshift-node
  6. annotations:
  7. kubernetes.io/description: |
  8. This daemon set provides dynamic configuration of nodes and relabels nodes as appropriate.
  9. image.openshift.io/triggers: |
  10. [
  11. {"from":{"kind":"ImageStreamTag","name":"node:v3.10"},"fieldPath":"spec.template.spec.containers[?(@.name==\"sync\")].image"}
  12. ]
  13. spec:
  14. selector:
  15. matchLabels:
  16. app: sync
  17. updateStrategy:
  18. type: RollingUpdate
  19. rollingUpdate:
  20. maxUnavailable: 50%
  21. template:
  22. metadata:
  23. labels:
  24. app: sync
  25. component: network
  26. type: infra
  27. openshift.io/component: sync
  28. annotations:
  29. scheduler.alpha.kubernetes.io/critical-pod: ''
  30. spec:
  31. serviceAccountName: sync
  32. terminationGracePeriodSeconds: 1
  33. # Must be hostPID because it invokes operations on processes in the host space.
  34. hostPID: true
  35. # Must be hostNetwork in order to schedule before any network plugins are loaded.
  36. hostNetwork: true
  37. containers:
  38. # The sync container is a temporary config loop until Kubelet dynamic config is implemented. It refreshes
  39. # the contents of /etc/origin/node/ with the config map ${BOOTSTRAP_CONFIG_NAME} from the openshift-node
  40. # namespace. It will restart the Kubelet on the host if it detects the node-config.yaml has changed.
  41. #
  42. # 1. Dynamic Kubelet config must pull down a full configmap
  43. # 2. Nodes must relabel themselves https://github.com/kubernetes/kubernetes/issues/59314
  44. #
  45. - name: sync
  46. image: " "
  47. command:
  48. - /bin/bash
  49. - -c
  50. - |
  51. #!/bin/bash
  52. set -euo pipefail
  53. # set by the node image
  54. unset KUBECONFIG
  55. trap 'kill $(jobs -p); exit 0' TERM
  56. # track the current state of the config
  57. if [[ -f /etc/origin/node/node-config.yaml ]]; then
  58. md5sum /etc/origin/node/node-config.yaml > /tmp/.old
  59. else
  60. touch /tmp/.old
  61. fi
  62. # loop until BOOTSTRAP_CONFIG_NAME is set
  63. while true; do
  64. file=/etc/sysconfig/origin-node
  65. if [[ -f /etc/sysconfig/atomic-openshift-node ]]; then
  66. file=/etc/sysconfig/atomic-openshift-node
  67. elif [[ -f /etc/sysconfig/origin-node ]]; then
  68. file=/etc/sysconfig/origin-node
  69. else
  70. echo "info: Waiting for the node sysconfig file to be created" 2>&1
  71. sleep 15 & wait
  72. continue
  73. fi
  74. name="$(sed -nE 's|^BOOTSTRAP_CONFIG_NAME=([^#].+)|\1|p' "${file}" | head -1)"
  75. if [[ -z "${name}" ]]; then
  76. echo "info: Waiting for BOOTSTRAP_CONFIG_NAME to be set" 2>&1
  77. sleep 15 & wait
  78. continue
  79. fi
  80. # in the background check to see if the value changes and exit if so
  81. pid=$BASHPID
  82. (
  83. while true; do
  84. if ! updated="$(sed -nE 's|^BOOTSTRAP_CONFIG_NAME=([^#].+)|\1|p' "${file}" | head -1)"; then
  85. echo "error: Unable to check for bootstrap config, exiting" 2>&1
  86. kill $pid
  87. exit 1
  88. fi
  89. if [[ "${updated}" != "${name}" ]]; then
  90. echo "info: Bootstrap configuration profile name changed, exiting" 2>&1
  91. kill $pid
  92. exit 0
  93. fi
  94. sleep 15
  95. done
  96. ) &
  97. break
  98. done
  99. # periodically refresh both node-config.yaml and relabel the node
  100. while true; do
  101. if ! oc extract "configmaps/${name}" -n openshift-node --to=/etc/origin/node --confirm --request-timeout=10s --config /etc/origin/node/node.kubeconfig "--token=$( cat /var/run/secrets/kubernetes.io/serviceaccount/token )" > /dev/null; then
  102. echo "error: Unable to retrieve latest config for node" 2>&1
  103. sleep 15 &
  104. wait $!
  105. continue
  106. fi
  107. # detect whether the node-config.yaml has changed, and if so trigger a restart of the kubelet.
  108. md5sum /etc/origin/node/node-config.yaml > /tmp/.new
  109. if [[ "$( cat /tmp/.old )" != "$( cat /tmp/.new )" ]]; then
  110. echo "info: Configuration changed, restarting kubelet" 2>&1
  111. # TODO: kubelet doesn't relabel nodes, best effort for now
  112. # https://github.com/kubernetes/kubernetes/issues/59314
  113. if args="$(openshift start node --write-flags --config /etc/origin/node/node-config.yaml)"; then
  114. labels=$(tr ' ' '\n' <<<$args | sed -ne '/^--node-labels=/ { s/^--node-labels=//; p; }' | tr ',\n' ' ')
  115. if [[ -n "${labels}" ]]; then
  116. echo "info: Applying node labels $labels" 2>&1
  117. if ! oc label --config=/etc/origin/node/node.kubeconfig "node/${NODE_NAME}" ${labels} --overwrite; then
  118. echo "error: Unable to apply labels, will retry in 10" 2>&1
  119. sleep 10 &
  120. wait $!
  121. continue
  122. fi
  123. fi
  124. else
  125. echo "error: The downloaded node configuration is invalid, exiting" 2>&1
  126. exit 1
  127. fi
  128. if ! kill $(pgrep -U 0 -f '^/usr/bin/hyperkube kubelet ' | head -n1); then
  129. echo "error: Unable to restart Kubelet" 2>&1
  130. fi
  131. fi
  132. cp -f /tmp/.new /tmp/.old
  133. sleep 180 &
  134. wait $!
  135. done
  136. env:
  137. - name: NODE_NAME
  138. valueFrom:
  139. fieldRef:
  140. fieldPath: spec.nodeName
  141. securityContext:
  142. runAsUser: 0
  143. privileged: true
  144. volumeMounts:
  145. # Directory which contains the host configuration. We read from this directory
  146. - mountPath: /etc/origin/node/
  147. name: host-config
  148. - mountPath: /etc/sysconfig
  149. name: host-sysconfig-node
  150. readOnly: true
  151. volumes:
  152. # In bootstrap mode, the host config contains information not easily available
  153. # from other locations.
  154. - name: host-config
  155. hostPath:
  156. path: /etc/origin/node
  157. - name: host-sysconfig-node
  158. hostPath:
  159. path: /etc/sysconfig